// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024-2025  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <aoc/common/Graph.hpp>
#include <aoc/framework/Solver-types.hpp>

class LanParty
    : public Solver<long long, std::string>
{
public:
    virtual const std::string getPuzzleName() const override;
    virtual const int getPuzzleDay() const override;
    virtual void processDataLine(const std::string& line) override;
    virtual void finish() override;
private:
    Graph lan_;
    void computeInterconnectedThreeSetCount(const Vertex& vertexTx);
    bool shallProcessVertex(const Vertex& vertexToCheck, const Vertex& vertexTx) const;
    const std::string getFirstTxComputerName() const;
    const std::string getLastTxComputerName() const;
};
